#pragma once

#include "Boss.h"
#include "../Game/StdInc.h"
#include "../Time/TickTimer.h"
#include "../Sprite/ShallowSprite.h"

namespace _AI
{

#define DREAD_HEALTH		200
#define DREAD_RAGE_TIME		MilliToNano(5000)
#define DREAD_RAGE_HIT		20

class Dread : public Boss
{
stealth:
	enum DREAD_ATTACK_STATE { PRIM_STD = 0, PRIM_HVY, SCND_STD, SCND_HVY, SUPER} attackState;
	void primaryStd();
	void primaryHvy();
	void secondaryStd();
	void secondaryHvy();
	void superAttack();
	void setState(DREAD_ATTACK_STATE);
	void shoot(float x, float y, const D3DXVECTOR3 &dir);

	_TIME::TimerHandle patternTimer;
	std::list<double> hitTime;
	bool patternDone;
	int shotCount;

public:
	Dread(const PhysicalObject& po = PhysicalObject());
	void updateAI();
	void hitEvent();

	void playerSpreadBulletCollision(_PHYSICS::CollisionResult &result);
	void playerAutomaticBulletCollision(_PHYSICS::CollisionResult &result);
	void playerBulletCollision(_PHYSICS::CollisionResult &result);

	void frameUpdate(){}
	void attack(){}
	void move(){}
	void execState();
};

}